unit StarShow1;

interface

uses Windows,Math,Graphics,SysUtils;
type
    TPoint3D=record
            X,Y,Z:Real;
end;

    procedure DrawToGrid(Vosh,Sclon,ugol,ugl:Single;Mag:byte;Nam:string;opt:byte);
    procedure Line(VoshFrom,SclonFrom,VoshTo,SclonTo,ugol,ugl:Single);
    function  ThreeD_to_2D(Point:Tpoint3D):TPoint;
    function  Rotate      (V:TPoint3D; Angle:Extended):TPoint3D;
    function  ConvertTo3D(Sclon,Vosh,Ugl:Single):TPoint3D;
    procedure DrawEquator();
//    procedure DrawPoles();

implementation
uses Stars_1;

const
     Radius      =190;
     constant    =300;
     Aspect=1.4333;
     U=-55;
function ConvertTo3D(Sclon,Vosh,Ugl:Single):TPoint3D;
var
   P:TPoint3D;
begin
     P.X:=radius*sin(DegToRad(90-Sclon))*cos(DegToRad((Vosh)*15+Ugl));
     P.Y:=radius*Sin(DegToRad(90-Sclon))*Sin(DegToRad((Vosh)*15+Ugl));
     P.Z:=radius*cos(DegToRad(90-Sclon));
     result:=P;
end;

procedure DrawToGrid(Vosh,Sclon,ugol,ugl:Single;Mag:byte;Nam:string;opt:byte);
var
indx             :integer;
P                :TPoint3D;
P1               :TPoint;
begin
     indx:=0;
     if Sclon<-35 then exit;
     P:=ConvertTo3D(Sclon,Vosh,Ugl);
     P:=Rotate(P,DegToRad(U));

     if (P.Z>0) AND (Sclon<(90-Ugol)) then exit;

     P1:=ThreeD_to_2D(P);
     case MAG of
          0:indx:=4;
          1:indx:=3;
          2:indx:=2;
          3:indx:=1;
          4:indx:=1;
     end;
     BMP.Canvas.Ellipse(P1.X-(indx div 2),P1.Y-(indx div 2),
                        P1.X+(indx div 2),P1.Y+(indx div 2));


if opt>=Mag then
begin
     BMP.Canvas.Brush.Style:=bsClear;
     BMP.Canvas.TextOut(P1.X+2,P1.Y+2,Nam);
end;

end;

procedure Line(VoshFrom,SclonFrom,VoshTo,SclonTo,ugol,ugl:Single);
var
   P0,P1:TPoint3D;
   P2,P3:Tpoint;
begin
     if SclonFrom<-35 then exit;
     P0:=ConvertTo3D(SclonFrom,VoshFrom,Ugl);
     P0:=Rotate(P0,DegToRad(U));
     if (P0.Z>0) AND (SclonFrom<(90-Ugol))then exit;

     P2:=ThreeD_to_2D(P0);

     if SclonTo<-35 then exit;
     P1:=ConvertTo3D(SclonTo,VoshTo,Ugl);
     P1:=Rotate(P1,DegToRad(U));

     if (p1.Z>0) AND (SclonTo<(90-Ugol)) then exit;

     P3:=ThreeD_to_2D(P1);

     Stars_1.BMP.Canvas.MoveTo(P2.X,p2.Y);
     Stars_1.BMP.Canvas.LineTo(P3.X,P3.y);
end;


function  Rotate(V:TPoint3D; Angle:Extended):TPoint3D;
var
   Tmp:TPoint3D;
begin
     Tmp.X:=V.X;
     Tmp.Y:=V.Y*cos(DegToRad(-45)+Angle)-V.Z*sin(DegToRad(-45)+Angle);
     Tmp.Z:=V.Y*Sin(DegToRad(-45)+Angle)+V.Z*Cos(DegToRad(-45)+Angle);
     Result:=Tmp;
end;

function  ThreeD_to_2D(Point:Tpoint3D):TPoint;
Var
  Dx,Dy : Real;
  P:Tpoint;
//  ugol:integer;
//  k:Extended;
Begin
//     ugol:=0;
     P.X:=400;
     P.Y:=300;
//   k:=1.4;
     Dx:=0;             //(Point.Y)*Sin(DegToRad(ugol));
     Dy:=-(Point.Y) ;   //  *Cos(DegToRad(ugol));//*k;
     Dx:=Dx+(Point.X) ; //*Sin(DegToRad(90-ugol));//*k;
                        //Dy:=Dy+(Point.X)*Cos(DegToRad(90-ugol));
     Dy:=Dy-Point.Z;

     P.X:=Round(((P.X / Aspect)+Int(Dx))*Aspect);//+115
     P.Y:=Round((P.Y+Int(Dy)));                  //+80
     result:=P;
End;

procedure DrawEquator();
var
   i:integer;
   x,y:integer;
//   P:TPoint3D;
   d:Single;
   points:array[0..24] of TPoint;
begin
     BMP.Canvas.Pen.Color:=clTeal;
     BMP.Canvas.Pen.Mode:=pmCopy;
     for i:=0 to 24 do
     begin
          x:=-round(90*sin(DegToRad(i/2*15-90)));
          y:= round(90*cos(DegToRad(i/2*15-90)));
//          d:=sqrt((400-x)*(400-x)+(300-y)*(300-y));
//          if d<=270 then
//          begin
               Points[i].X:=X*3+CenterX;
               Points[i].Y:=Y*3+CenterY;
//          end;
     end;
     BMP.Canvas.PolyLine(Points);
end;

end.
