unit Stars_1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, ToolWin, StdCtrls, Mask ,Math, Buttons,
  StarUtils,AstroUtils;

type
  TStarFrm = class(TForm)
    Timer1: TTimer;
    Panel1: TPanel;
    SpeedButton2: TSpeedButton;
    Sun: TImage;
    Merc: TImage;
    Venus: TImage;
    Earth: TImage;
    Mars: TImage;
    Jove: TImage;
    Saturn: TImage;
    Moon: TImage;
    procedure ToolButton3Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ToolButton4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Type
    TStarRec=record
         Vosh     :Single;
         Sclon    :Single;
         Magnitude:byte;
         Bukva    :byte;
         Nomer    :string[3];
         Name     :string[20];
    end;
    TConstellation=record
         A,B,C,D:SmallInt;
    end;
    TConstellationName=record
         Ra,Dec:SmallInt;
         Name:string[25];
    end;
var
  StarFrm   : TStarFrm;
  i         : integer;
  Hour      : integer;
  Ugol_Rot  : Single=-140.0;
  Star_Array: array[0..10000] of TStarRec;
  Cons_Array: array[0..700] of TConstellation;
  Cons_Names: array[0..700] of TConstellationName;
  Sky       : TSky;
  BMP       : TBItmap;

const
     Latitude = 55.0;
implementation

{$R *.DFM}


procedure TStarFrm.ToolButton3Click(Sender: TObject);
var
   _a,_b,_c,_d:Single;
   j:integer;
begin
with BMP.Canvas do
begin
     Brush.Color:=clBlack;
     FillRect(ClientRect);

     Pen.Color:=clBlue;
     Brush.Style:=bsClear;
     Ellipse((Screen.Width div 2)-(Screen.Height div 2),0,
             (Screen.Width div 2)+(Screen.Height div 2),Screen.Height);
     Brush.Style:=bsSolid;

     Brush.COlor:=clWhite;
     Pen.Color:=clGray;
end;
     j:=0;
     repeat
           _a:=Cons_Array[j].A/1000;   //RA From
           _b:=Cons_Array[j].B/100;    //Dec from
           _c:=Cons_Array[j].C/1000;   //RA to
           _d:=Cons_Array[j].D/100;    //Dec to
           Sky.Draw_Constellation(BMP,_a,_b,_c,_d,Ugol_Rot);
          inc(j)
     until Cons_Array[j].A=0;
j:=0;

repeat
     with BMP.Canvas do
     begin
          Brush.COlor:=clWhite;
          Pen.Color:=clWhite;

          if (Star_Array[j].Magnitude<=1) then
           begin
                Sky.Draw_Star(BMP,Star_Array[j].Vosh,Star_Array[j].Sclon,
                          Ugol_Rot,Star_Array[j].Magnitude,0,Star_Array[j].Name);
           end;

     end;
     inc(j);
until Star_Array[j].Magnitude>1;

     Sky.Draw_Equator(BMP);
     Sky.Draw_Poles(BMP);
     Sky.Draw_Ecliptic(BMP);
     Sky.Draw_Constellation_Names(BMP);
     Sky.Draw_Sun(BMP,Sun.Picture.Bitmap);
     Sky.Draw_Moon(BMP,Moon.Picture.Bitmap);

     if SpeedButton2.Tag=1 then Sky.Draw_Grid(BMP,15,15);
     StarFrm.Canvas.Draw(0,0,BMP);
end;

procedure TStarFrm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=VK_LEFT  then
        begin
             Ugol_Rot:=Ugol_Rot-5;
             ToolButton3Click(Self);
        end;
     if key=VK_RIGHT then
        begin
             Ugol_Rot:=Ugol_Rot+5;
             ToolButton3Click(Self);
        end;
     if key=VK_ESCAPE then StarFrm.Close;

end;

procedure TStarFrm.ToolButton4Click(Sender: TObject);
begin
Application.Terminate;
end;

procedure TStarFrm.Timer1Timer(Sender: TObject);
var
   T:TSystemTime;
   tc,tc2:LongInt;
   corr_ugol:Extended;
begin
     GetSystemTime(T);
{     T.wYear  :=2000;
     T.wMonth :=10;
     T.wDay   :=27;
     T.wHour  :=14;
     T.wMinute:=00;
     T.wSecond:=00;}

     tc:=GetTickCount;

     T.wHour:=(T.wHour mod 24);

     corr_ugol:=((JulianDay(T.wYear,T.wMonth,T.wDay)-JulianDay(T.wYear,03,23))/(365.25/24));
     corr_ugol:=round(corr_ugol);


     Ugol_Rot:=180-(T.wHour+Hour+corr_ugol+1/60*T.wMinute+1/3600*T.wSecond)*15;

     StarFrm.ToolButton3Click(Self);
     tc2:=GetTickCount;

     Font.Color:=clWhite;
     Canvas.TextOut(20,Screen.Height-abs(Canvas.Font.Height),'Calculation: '+FloatToStr((tc2-tc)/1000)+' sec');

end;

procedure TStarFrm.FormShow(Sender: TObject);
var
   T:TSystemTime;
begin
     GetSystemTime(T);
     Sky.Create;
     BMP:=TBitmap.Create;
     BMP.Width:=Screen.Width;
     BMP.Height:=Screen.Height;

     if (T.wMonth>10) and (T.wMonth<4) then Hour:=1 else Hour:=2;

end;

procedure TStarFrm.SpeedButton2Click(Sender: TObject);
begin
SpeedButton2.Tag:=1-SpeedButton2.Tag;
Sky.Draw_Grid(BMP,15,15);
Canvas.Draw(0,0,BMP);
end;

end.
